/*
plotutils.c
fdtd2d/fdtd3d
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "ev.h"

extern void getminmax3d(int, int, int, int, int, int, int, float ***, float *, float *);

// }
void plot2d_contour(float x0, float y0, int nx, int ny,
	float **d, float dmin, float dmax, int color, int grid)
{
	// }ihԂj
	for (int i = 0; i < nx; i++) {
	for (int j = 0; j < ny; j++) {
		const float v = (d[i][j] - dmin) / (dmax - dmin);
		ev2d_setColorV(v, (color > 0));
		ev2d_fillRectangle(x0 + i, y0 + j, x0 + i + 1, y0 + j + 1);
	}
	}

	// Og
	if (color == 0) {
		ev2d_setColor(0, 0, 0);
		ev2d_drawRectangle(x0, y0, x0 + nx, y0 + ny);
	}

	// Obh
	if (grid) {
		ev2d_setColor(160, 160, 160);
		for (int i = 1; i < nx; i++) {
			ev2d_drawLine(x0 + i, y0, x0 + i, y0 + ny);
		}
		for (int j = 1; j < ny; j++) {
			ev2d_drawLine(x0, y0 + j, x0 + nx, y0 + j);
		}
	}
}


// Ss
void plot2d_s(int mx, int my, int ndata, int nstep, int ntx, int nrx,
	float ***s_r, float ***s_i, int grid, const char fn[])
{
	char str[BUFSIZ], fmt[BUFSIZ];

	// SsΒl
	float ***d = (float ***)malloc(ndata * sizeof(float **));
	for (int idata = 0; idata < ndata; idata++) {
		d[idata] = (float **)malloc(ntx * sizeof(float *));
		for (int itx = 0; itx < ntx; itx++) {
			d[idata][itx] = (float *)malloc(nrx * sizeof(float));
		}
	}
	for (int idata = 0; idata < ndata; idata++) {
		for (int itx = 0; itx < ntx; itx++) {
		for (int irx = 0; irx < nrx; irx++) {
			d[idata][itx][irx] = (float)sqrt((s_r[idata][itx][irx] * s_r[idata][itx][irx])
			                               + (s_i[idata][itx][irx] * s_i[idata][itx][irx]));
		}
		}
	}

	// ŏEő
	float dmin, dmax;
	getminmax3d(0, ndata, 0, ntx, 0, nrx, 0, d, &dmin, &dmax);

	// Jn
	const float s = 2;
	const float w = (mx * ntx) + ((mx + 1) * s);
	const float h = (my * nrx) + ((my + 1) * s);
	ev2d_init(w, h);
	ev2d_newPage();

	// }, 1f[^=1}
	int num = 0;
	for (int px = 0; px < mx; px++) {
	for (int py = 0; py < my; py++) {
		if (num * nstep < ndata) {
			// _
			const float x0 = (px * ntx) + ((px + 1) * s);
			const float y0 = (py * nrx) + ((py + 1) * s);

			// }
			plot2d_contour(x0, y0, ntx, nrx, d[num * nstep], dmin, dmax, 1, grid);

			// f[^ԍ
			ev2d_setColor(0, 0, 0);
			sprintf(str, "%d", num * nstep + 1);
			ev2d_drawString(x0, y0 + nrx - h / 60, h / 60, str);

			// }++
			num++;
		}
	}
	}
	free(d);

	// ŏEő
	strcpy(fmt, "data=%d fig=%d step=%d Tx=%d Rx=%d min=%.6f max=%.6f");
	sprintf(str, fmt, ndata, num, nstep, ntx, nrx, dmin, dmax);
	ev2d_setColor(0, 0, 0);
	ev2d_drawString(s, s, h / 40, str);

	// o
	ev2d_file(1, fn);
	ev2d_output();
}
