/*
txrx.c
送受信点座標
*/

#include <stdio.h>
#include <assert.h>

void txrx(int Nx, int Ny, int Nout, int Lant,
	int NTx, int DTx, int *iTx, int *jTx,
	int NRx, int DRx, int *iRx, int *jRx)
{
	// 送信点
	for (int itx = 0; itx < NTx; itx++) {
		iTx[itx] = Nout - Lant;
		jTx[itx] = Nout + (itx + 1) * DTx;
	}

	// 受信点
	for (int irx = 0; irx < NRx; irx++) {
		iRx[irx] = Nx - Nout + Lant;
		jRx[irx] = Nout + (irx + 1) * DRx;
	}

	// check
	for (int itx = 0; itx < NTx; itx++) {
		//printf("%d %d %d\n", itx, iTx[itx], jTx[itx]);
		assert((iTx[itx] > 0) && (iTx[itx] < Nx) && (jTx[itx] > 0) && (jTx[itx] < Ny));
	}
	for (int irx = 0; irx < NRx; irx++) {
		//printf("%d %d %d\n", irx, iRx[irx], jRx[irx]);
		assert((iRx[irx] > 0) && (iRx[irx] < Nx) && (jRx[irx] > 0) && (jRx[irx] < Ny));
	}
}
