/*
plot3d.c
3D}`o, debugp
*/

#include <stdio.h>
#include <string.h>
#include "../fdtd2d/ev.h"

// vZ̈, Uď`, M_
void plot3d_g(int Nx, int Ny, int Nz, int Nout, int Ndata, int npage,
	int nrect, int **rect, int NTx, int *iTx, int *jTx, int *kTx, int NRx, int *iRx, int *jRx, int *kRx, const char fn[])
{
	// Jn
	ev3d_init();

	// 1f[^=1y[W
	if (npage > Ndata) npage = Ndata;
	if (Ndata == 0) npage = 1;
	for (int idata = 0; idata < npage; idata++) {

		ev3d_newPage();

		// vZ̈
		ev3d_setColor(100, 100, 100);
		ev3d_drawBox(0, 0, 0, Nx, Ny, Nz);
		ev3d_drawBox(Nout, Nout, Nout, Nx - Nout, Ny - Nout, Nz - Nout);

		// Ud
		if (Ndata > 0) {
			ev3d_setColor(0, 0, 255);
			for (int irect = 0; irect < nrect; irect++) {
				int *p = &rect[idata][6 * irect];
				ev3d_drawBox(p[0], p[1], p[2], p[3], p[4], p[5]);
			}
		}

		// M_(Z)
		ev3d_setColor(255, 0, 0);
		for (int itx = 0; itx < NTx; itx++) {
			const int i = iTx[itx];
			const int j = jTx[itx];
			const int k = kTx[itx];
			ev3d_drawLine(i, j, k, i, j, k + 1);
		}

		// M_(Z)
		ev3d_setColor(0, 255, 0);
		for (int irx = 0; irx < NRx; irx++) {
			const int i = iRx[irx];
			const int j = jRx[irx];
			const int k = kRx[irx];
			ev3d_drawLine(i, j, k, i, j, k + 1);
		}

		// ^Cg
		char str[BUFSIZ];
		const int mx = Nx - 2 * Nout;
		const int my = Ny - 2 * Nout;
		const int mz = Nz - 2 * Nout;
		sprintf(str, "Nx=%d Ny=%d Nz=%d Mx=%d My=%d Mz=%d Tx=%d Rx=%d", Nx, Ny, Nz, mx, my, mz, NTx, NRx);
		ev3d_drawTitle(str);
	}

	// o
	ev3d_file(1, fn, 0);
	ev3d_output();
}
